<?xml version="1.0" encoding="utf-8"?>
<LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:app="http://schemas.android.com/apk/res-auto"
    xmlns:tools="http://schemas.android.com/tools"
    android:layout_width="wrap_content"
    android:layout_height="wrap_content"
    tools:context=".GeneratorActivity">

    <androidx.constraintlayout.widget.ConstraintLayout
        android:layout_width="350dp"
        android:layout_height="wrap_content"
        app:layout_constraintStart_toStartOf="parent"
        app:layout_constraintTop_toTopOf="parent">

        <ProgressBar
            android:id="@+id/progressBar"
            style="?android:attr/progressBarStyleHorizontal"
            android:layout_width="256dp"
            android:layout_height="10dp"
            android:layout_marginStart="80dp"
            android:layout_marginTop="100dp"
            android:layout_marginEnd="80dp"
            android:progress="2"
            android:min="0"
            android:max="4"
            app:layout_constraintEnd_toEndOf="parent"
            app:layout_constraintStart_toStartOf="parent"
            app:layout_constraintTop_toTopOf="parent" />

        <TextView
            android:id="@+id/random_string"
            android:layout_width="201dp"
            android:layout_height="wrap_content"
            android:layout_marginStart="80dp"
            android:layout_marginEnd="80dp"
            android:layout_marginBottom="10dp"
            android:gravity="center_vertical"
            android:text="D%g$MA0H8d"
            android:textAlignment="center"
            android:textAppearance="@style/TextAppearance.AppCompat.Body1"
            android:textSize="30sp"
            app:layout_constraintBottom_toTopOf="@+id/progressBar"
            app:layout_constraintEnd_toEndOf="parent"
            app:layout_constraintStart_toStartOf="parent" />

        <ImageButton
            android:id="@+id/refresh_button"
            android:layout_width="32dp"
            android:layout_height="32dp"
            android:layout_marginEnd="16dp"
            android:layout_marginBottom="16dp"
            android:background="#00FFFFFF"
            app:layout_constraintBottom_toTopOf="@+id/progressBar"
            app:layout_constraintEnd_toStartOf="@+id/random_string"
            app:srcCompat="@drawable/ic_refresh" />

        <ImageButton
            android:id="@+id/copy_button"
            android:layout_width="32dp"
            android:layout_height="32dp"
            android:layout_marginStart="16dp"
            android:layout_marginBottom="16dp"
            android:background="#00FFFFFF"
            app:layout_constraintBottom_toTopOf="@+id/progressBar"
            app:layout_constraintStart_toEndOf="@+id/random_string"
            app:srcCompat="@drawable/ic_content_copy" />

        <LinearLayout
            android:id="@+id/password_length_container"
            android:layout_width="142dp"
            android:layout_height="45dp"
            android:layout_marginStart="1dp"
            android:layout_marginTop="24dp"
            android:layout_marginEnd="1dp"
            android:orientation="horizontal"
            app:layout_constraintEnd_toEndOf="parent"
            app:layout_constraintHorizontal_bias="0.498"
            app:layout_constraintStart_toStartOf="parent"
            app:layout_constraintTop_toBottomOf="@+id/progressBar">

            <ImageButton
                android:id="@+id/subtract_button"
                android:layout_width="wrap_content"
                android:layout_height="wrap_content"
                android:layout_marginTop="7dp"
                android:layout_weight="1"
                android:background="#00FFFFFF"
                app:srcCompat="@drawable/ic_remove" />

            <TextView
                android:id="@+id/length_label"
                android:layout_width="45dp"
                android:layout_height="match_parent"
                android:layout_weight="1"
                android:fontFamily="sans-serif-light"
                android:gravity="center_horizontal|center_vertical"
                android:text="0"
                android:textColor="@color/colorPrimaryDark"
                android:textSize="24sp" />

            <ImageButton
                android:id="@+id/add_button"
                android:layout_width="wrap_content"
                android:layout_height="wrap_content"
                android:layout_marginTop="7dp"
                android:layout_weight="1"
                android:background="#00FFFFFF"
                app:srcCompat="@drawable/ic_add" />

        </LinearLayout>

        <CheckBox
            android:id="@+id/AZ"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content"
            android:layout_marginStart="32dp"
            android:layout_marginTop="32dp"
            android:checked="true"
            android:text="A-Z"
            android:textSize="20sp"
            app:layout_constraintStart_toStartOf="parent"
            app:layout_constraintTop_toBottomOf="@+id/password_length_container" />

        <CheckBox
            android:id="@+id/az"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content"
            android:layout_marginStart="32dp"
            android:layout_marginTop="8dp"
            android:checked="true"
            android:text="a-z"
            android:textSize="20sp"
            app:layout_constraintStart_toStartOf="parent"
            app:layout_constraintTop_toBottomOf="@+id/AZ" />

        <CheckBox
            android:id="@+id/zero_nine"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content"
            android:layout_marginStart="32dp"
            android:layout_marginTop="8dp"
            android:checked="true"
            android:text="0-9"
            android:textSize="20sp"
            app:layout_constraintStart_toStartOf="parent"
            app:layout_constraintTop_toBottomOf="@+id/az" />

        <CheckBox
            android:id="@+id/special"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content"
            android:layout_marginStart="32dp"
            android:layout_marginTop="8dp"
            android:checked="true"
            android:text="!&quot;#$%'()*+"
            android:textSize="20sp"
            app:layout_constraintStart_toStartOf="parent"
            app:layout_constraintTop_toBottomOf="@+id/zero_nine" />

        <CheckBox
            android:id="@+id/emojis"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content"
            android:layout_marginStart="32dp"
            android:layout_marginTop="8dp"
            android:text="😃👽😺👋"
            android:textSize="20sp"
            app:layout_constraintStart_toStartOf="parent"
            app:layout_constraintTop_toBottomOf="@+id/special" />
    </androidx.constraintlayout.widget.ConstraintLayout>
</LinearLayout>